ompi/mca/pml/pml.h File Reference.TH "ompi/mca/pml/pml.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/mca/pml/pml.h \- P2P Management Layer (PML). 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include 'opal/class/opal_list.h'\fP
.br
\fC#include 'mca/mca.h'\fP
.br
\fC#include 'mpi.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBOMPI_ANY_TAG\fP   MPI_ANY_TAG"
.br
.ti -1c
.RI "#define \fBOMPI_ANY_SOURCE\fP   MPI_ANY_SOURCE"
.br
.ti -1c
.RI "#define \fBOMPI_PROC_NULL\fP   MPI_PROC_NULL"
.br
.ti -1c
.RI "#define \fBMCA_PML_BASE_VERSION_1_0_0\fP"
.br
.ti -1c
.RI "#define \fBMCA_PML_CALL\fP(a)   mca_pml.pml_ ## a"
.br
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef mca_pml_proc_t \fBmca_pml_proc_t\fP"
.br
.ti -1c
.RI "typedef \fBmca_pml_base_module_1_0_0_t\fP *(* \fBmca_pml_base_component_init_fn_t\fP )(int *priority, bool enable_progress_threads, bool enable_mpi_threads)"
.br
.RI "\fIMCA->PML Called by MCA framework to initialize the component. \fP"
.ti -1c
.RI "typedef int(* \fBmca_pml_base_component_finalize_fn_t\fP )(void)"
.br
.ti -1c
.RI "typedef \fBmca_pml_base_component_1_0_0_t\fP \fBmca_pml_base_component_1_0_0_t\fP"
.br
.ti -1c
.RI "typedef \fBmca_pml_base_component_1_0_0_t\fP \fBmca_pml_base_component_t\fP"
.br
.ti -1c
.RI "typedef int(* \fBmca_pml_base_module_add_procs_fn_t\fP )(struct ompi_proc_t **procs, size_t nprocs)"
.br
.RI "\fIDowncall from MPI/RTE layer when new processes are created. \fP"
.ti -1c
.RI "typedef int(* \fBmca_pml_base_module_del_procs_fn_t\fP )(struct ompi_proc_t **procs, size_t nprocs)"
.br
.RI "\fIDowncall from MPI/RTE layer when processes are terminated. \fP"
.ti -1c
.RI "typedef int(* \fBmca_pml_base_module_enable_fn_t\fP )(bool enable)"
.br
.RI "\fIDowncall from MCA layer to enable the PML/PTLs. \fP"
.ti -1c
.RI "typedef int(* \fBmca_pml_base_module_progress_fn_t\fP )(void)"
.br
.RI "\fIFor non-threaded case, provides MCA the opportunity to progress outstanding requests on all ptls. \fP"
.ti -1c
.RI "typedef int(* \fBmca_pml_base_module_add_comm_fn_t\fP )(struct ompi_communicator_t *comm)"
.br
.RI "\fIDowncall from MPI layer when a new communicator is created. \fP"
.ti -1c
.RI "typedef int(* \fBmca_pml_base_module_del_comm_fn_t\fP )(struct ompi_communicator_t *comm)"
.br
.RI "\fIDowncall from MPI layer when a communicator is destroyed. \fP"
.ti -1c
.RI "typedef int(* \fBmca_pml_base_module_irecv_init_fn_t\fP )(void *buf, size_t count, struct ompi_datatype_t *datatype, int src, int tag, struct ompi_communicator_t *comm, struct \fBompi_request_t\fP **request)"
.br
.RI "\fIInitialize a persistent receive request. \fP"
.ti -1c
.RI "typedef int(* \fBmca_pml_base_module_irecv_fn_t\fP )(void *buf, size_t count, struct ompi_datatype_t *datatype, int src, int tag, struct ompi_communicator_t *comm, struct \fBompi_request_t\fP **request)"
.br
.RI "\fIPost a receive request. \fP"
.ti -1c
.RI "typedef int(* \fBmca_pml_base_module_recv_fn_t\fP )(void *buf, size_t count, struct ompi_datatype_t *datatype, int src, int tag, struct ompi_communicator_t *comm, ompi_status_public_t *status)"
.br
.RI "\fIPost a receive and wait for completion. \fP"
.ti -1c
.RI "typedef int(* \fBmca_pml_base_module_isend_init_fn_t\fP )(void *buf, size_t count, struct ompi_datatype_t *datatype, int dst, int tag, mca_pml_base_send_mode_t mode, struct ompi_communicator_t *comm, struct \fBompi_request_t\fP **request)"
.br
.RI "\fIInitialize a persistent send request. \fP"
.ti -1c
.RI "typedef int(* \fBmca_pml_base_module_isend_fn_t\fP )(void *buf, size_t count, struct ompi_datatype_t *datatype, int dst, int tag, mca_pml_base_send_mode_t mode, struct ompi_communicator_t *comm, struct \fBompi_request_t\fP **request)"
.br
.RI "\fIPost a send request. \fP"
.ti -1c
.RI "typedef int(* \fBmca_pml_base_module_send_fn_t\fP )(void *buf, size_t count, struct ompi_datatype_t *datatype, int dst, int tag, mca_pml_base_send_mode_t mode, struct ompi_communicator_t *comm)"
.br
.RI "\fIPost a send request and wait for completion. \fP"
.ti -1c
.RI "typedef int(* \fBmca_pml_base_module_start_fn_t\fP )(size_t count, struct \fBompi_request_t\fP **requests)"
.br
.RI "\fIInitiate one or more persistent requests. \fP"
.ti -1c
.RI "typedef int(* \fBmca_pml_base_module_iprobe_fn_t\fP )(int src, int tag, struct ompi_communicator_t *comm, int *matched, ompi_status_public_t *status)"
.br
.RI "\fIProbe to poll for pending recv. \fP"
.ti -1c
.RI "typedef int(* \fBmca_pml_base_module_probe_fn_t\fP )(int src, int tag, struct ompi_communicator_t *comm, ompi_status_public_t *status)"
.br
.RI "\fIBlocking probe to wait for pending recv. \fP"
.ti -1c
.RI "typedef int(* \fBmca_pml_base_module_cancel_fn_t\fP )(struct \fBompi_request_t\fP *request)"
.br
.RI "\fICancel pending operation. \fP"
.ti -1c
.RI "typedef int(* \fBmca_pml_base_module_cancelled_fn_t\fP )(struct \fBompi_request_t\fP *request, int *flag)"
.br
.RI "\fIHas a request been cancelled? \fP"
.ti -1c
.RI "typedef int(* \fBmca_pml_base_module_free_fn_t\fP )(struct \fBompi_request_t\fP **request)"
.br
.RI "\fIRelease resources held by a persistent mode request. \fP"
.ti -1c
.RI "typedef int(* \fBmca_pml_base_module_null_fn_t\fP )(struct \fBompi_request_t\fP **request)"
.br
.RI "\fIA special NULL request handle. \fP"
.ti -1c
.RI "typedef \fBmca_pml_base_module_1_0_0_t\fP \fBmca_pml_base_module_1_0_0_t\fP"
.br
.ti -1c
.RI "typedef \fBmca_pml_base_module_1_0_0_t\fP \fBmca_pml_base_module_t\fP"
.br
.in -1c
.SS "Enumerations"

.in +1c
.ti -1c
.RI "enum \fBmca_pml_base_send_mode_t\fP { \fBMCA_PML_BASE_SEND_STANDARD\fP, \fBMCA_PML_BASE_SEND_BUFFERED\fP, \fBMCA_PML_BASE_SEND_SYNCHRONOUS\fP, \fBMCA_PML_BASE_SEND_READY\fP }"
.br
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "OMPI_DECLSPEC \fBmca_pml_base_module_t\fP \fBmca_pml\fP"
.br
.in -1c
.SH "Detailed Description"
.PP 
P2P Management Layer (PML). 

An MCA component type that provides the P2P interface functionality required by the MPI layer. The PML is a relatively thin layer that primarily provides for the fragmentation and scheduling of messages over multiple transports (instances of the P2P Transport Layer (PTL) MCA component type) as depicted below:
.PP
------------------------------------ | MPI | ------------------------------------ | PML | ------------------------------------ | PTL (TCP) | PTL (SM) | PTL (...) | ------------------------------------
.PP
A single PML component is selected by the MCA framework during library initialization. Initially, all available PMLs are loaded (potentially as shared libraries) and their component open and init functions called. The MCA framework selects the component returning the highest priority and closes/unloads any other PML components that may have been opened.
.PP
After all of the MCA components are initialized, the MPI/RTE will make downcalls into the PML to provide the initial list of processes (ompi_proc_t instances), and notification of changes (add/delete).
.PP
The PML module must select the set of PTL components that are to be used to reach a given destination. These should be cached on a PML specific data structure that is hung off the ompi_proc_t.
.PP
The PML should then apply a scheduling algorithm (round-robin, weighted distribution, etc), to schedule the delivery of messages over the available PTLs.
.SH "Define Documentation"
.PP 
.SS "#define MCA_PML_BASE_VERSION_1_0_0"
.PP
\fBValue:\fP
.PP
.nf
/* pml v1.0 is chained to MCA v1.0 */ \
  MCA_BASE_VERSION_1_0_0, \
  /* pml v1.0 */ \
  'pml', 1, 0, 0
.fi
.SH "Typedef Documentation"
.PP 
.SS "typedef struct \fBmca_pml_base_module_1_0_0_t\fP*(* \fBmca_pml_base_component_init_fn_t\fP)(int *priority, bool enable_progress_threads, bool enable_mpi_threads)"
.PP
MCA->PML Called by MCA framework to initialize the component. 
.PP
\fBParameters:\fP
.RS 4
\fIpriority\fP (OUT) Relative priority or ranking used by MCA to selected a component.
.br
\fIenable_progress_threads\fP (IN) Whether this component is allowed to run a hidden/progress thread or not.
.br
\fIenable_mpi_threads\fP (IN) Whether support for multiple MPI threads is enabled or not (i.e., MPI_THREAD_MULTIPLE), which indicates whether multiple threads may invoke this component simultaneously or not. 
.RE
.PP

.SS "typedef int(* \fBmca_pml_base_module_add_comm_fn_t\fP)(struct ompi_communicator_t *comm)"
.PP
Downcall from MPI layer when a new communicator is created. 
.PP
\fBParameters:\fP
.RS 4
\fIcomm\fP Communicator 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or failure status.
.RE
.PP
Provides the PML the opportunity to initialize/cache a data structure on the communicator. 
.SS "typedef int(* \fBmca_pml_base_module_add_procs_fn_t\fP)(struct ompi_proc_t **procs, size_t nprocs)"
.PP
Downcall from MPI/RTE layer when new processes are created. 
.PP
\fBParameters:\fP
.RS 4
\fIprocs\fP Array of new processes 
.br
\fInprocs\fP Size of process array 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or failure status.
.RE
.PP
Provides a notification to the PML that new processes have been created, and provides the PML the opportunity to cache data (e.g. list of PTLs to use) on the ompi_proc_t data structure. 
.SS "typedef int(* \fBmca_pml_base_module_cancel_fn_t\fP)(struct \fBompi_request_t\fP *request)"
.PP
Cancel pending operation. 
.PP
\fBParameters:\fP
.RS 4
\fIrequest\fP (IN) Request 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or failure status. 
.RE
.PP

.SS "typedef int(* \fBmca_pml_base_module_cancelled_fn_t\fP)(struct \fBompi_request_t\fP *request, int *flag)"
.PP
Has a request been cancelled? 
.PP
\fBParameters:\fP
.RS 4
\fIrequest\fP (IN) Request 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or failure status. 
.RE
.PP

.SS "typedef int(* \fBmca_pml_base_module_del_comm_fn_t\fP)(struct ompi_communicator_t *comm)"
.PP
Downcall from MPI layer when a communicator is destroyed. 
.PP
\fBParameters:\fP
.RS 4
\fIcomm\fP Communicator 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or failure status.
.RE
.PP
Provides the PML the opportunity to cleanup any datastructures associated with the communicator. 
.SS "typedef int(* \fBmca_pml_base_module_del_procs_fn_t\fP)(struct ompi_proc_t **procs, size_t nprocs)"
.PP
Downcall from MPI/RTE layer when processes are terminated. 
.PP
\fBParameters:\fP
.RS 4
\fIprocs\fP Array of processes 
.br
\fInprocs\fP Size of process array 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or failure status.
.RE
.PP
Provides a notification to the PML that processes have gone away, and provides the PML the opportunity to cleanup any data cached on the ompi_proc_t data structure. 
.SS "typedef int(* \fBmca_pml_base_module_enable_fn_t\fP)(bool enable)"
.PP
Downcall from MCA layer to enable the PML/PTLs. 
.PP
\fBParameters:\fP
.RS 4
\fIenable\fP Enable/Disable PML forwarding 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or failure status. 
.RE
.PP

.SS "typedef int(* \fBmca_pml_base_module_free_fn_t\fP)(struct \fBompi_request_t\fP **request)"
.PP
Release resources held by a persistent mode request. 
.PP
\fBParameters:\fP
.RS 4
\fIrequest\fP (IN) Request 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or failure status. 
.RE
.PP

.SS "typedef int(* \fBmca_pml_base_module_iprobe_fn_t\fP)(int src, int tag, struct ompi_communicator_t *comm, int *matched, ompi_status_public_t *status)"
.PP
Probe to poll for pending recv. 
.PP
\fBParameters:\fP
.RS 4
\fIsrc\fP (IN) Source rank w/in communicator. 
.br
\fItag\fP (IN) User defined tag. 
.br
\fIcomm\fP (IN) Communicator. 
.br
\fImatched\fP (OUT) Flag indicating if matching recv exists. 
.br
\fIstatus\fP (OUT) Completion statuses. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or failure status. 
.RE
.PP

.SS "typedef int(* \fBmca_pml_base_module_irecv_fn_t\fP)(void *buf, size_t count, struct ompi_datatype_t *datatype, int src, int tag, struct ompi_communicator_t *comm, struct \fBompi_request_t\fP **request)"
.PP
Post a receive request. 
.PP
\fBParameters:\fP
.RS 4
\fIbuf\fP (IN) User buffer. 
.br
\fIcount\fP (IN) Number of elements of the specified datatype. 
.br
\fIdatatype\fP (IN) User defined datatype. 
.br
\fIsrc\fP (IN) Source rank w/in communicator. 
.br
\fItag\fP (IN) User defined tag. 
.br
\fIcomm\fP (IN) Communicator. 
.br
\fIrequest\fP (OUT) Request handle. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or failure status. 
.RE
.PP

.SS "typedef int(* \fBmca_pml_base_module_irecv_init_fn_t\fP)(void *buf, size_t count, struct ompi_datatype_t *datatype, int src, int tag, struct ompi_communicator_t *comm, struct \fBompi_request_t\fP **request)"
.PP
Initialize a persistent receive request. 
.PP
\fBParameters:\fP
.RS 4
\fIbuf\fP (IN) User buffer. 
.br
\fIcount\fP (IN) Number of elements of the specified datatype. 
.br
\fIdatatype\fP (IN) User defined datatype. 
.br
\fIsrc\fP (IN) Source rank w/in communicator. 
.br
\fItag\fP (IN) User defined tag. 
.br
\fIcomm\fP (IN) Communicator. 
.br
\fIrequest\fP (OUT) Request handle. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or failure status. 
.RE
.PP

.SS "typedef int(* \fBmca_pml_base_module_isend_fn_t\fP)(void *buf, size_t count, struct ompi_datatype_t *datatype, int dst, int tag, mca_pml_base_send_mode_t mode, struct ompi_communicator_t *comm, struct \fBompi_request_t\fP **request)"
.PP
Post a send request. 
.PP
\fBParameters:\fP
.RS 4
\fIbuf\fP (IN) User buffer. 
.br
\fIcount\fP (IN) Number of elements of the specified datatype. 
.br
\fIdatatype\fP (IN) User defined datatype. 
.br
\fIdst\fP (IN) Peer rank w/in communicator. 
.br
\fItag\fP (IN) User defined tag. 
.br
\fImode\fP (IN) Send mode (STANDARD,BUFFERED,SYNCHRONOUS,READY) 
.br
\fIcomm\fP (IN) Communicator. 
.br
\fIrequest\fP (OUT) Request handle. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or failure status. 
.RE
.PP

.SS "typedef int(* \fBmca_pml_base_module_isend_init_fn_t\fP)(void *buf, size_t count, struct ompi_datatype_t *datatype, int dst, int tag, mca_pml_base_send_mode_t mode, struct ompi_communicator_t *comm, struct \fBompi_request_t\fP **request)"
.PP
Initialize a persistent send request. 
.PP
\fBParameters:\fP
.RS 4
\fIbuf\fP (IN) User buffer. 
.br
\fIcount\fP (IN) Number of elements of the specified datatype. 
.br
\fIdatatype\fP (IN) User defined datatype. 
.br
\fIdst\fP (IN) Peer rank w/in communicator. 
.br
\fItag\fP (IN) User defined tag. 
.br
\fImode\fP (IN) Send mode (STANDARD,BUFFERED,SYNCHRONOUS,READY) 
.br
\fIcomm\fP (IN) Communicator. 
.br
\fIrequest\fP (OUT) Request handle. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or failure status. 
.RE
.PP

.SS "typedef int(* \fBmca_pml_base_module_null_fn_t\fP)(struct \fBompi_request_t\fP **request)"
.PP
A special NULL request handle. 
.PP
\fBParameters:\fP
.RS 4
\fIrequest\fP (OUT) Request 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or failure status. 
.RE
.PP

.SS "typedef int(* \fBmca_pml_base_module_probe_fn_t\fP)(int src, int tag, struct ompi_communicator_t *comm, ompi_status_public_t *status)"
.PP
Blocking probe to wait for pending recv. 
.PP
\fBParameters:\fP
.RS 4
\fIsrc\fP (IN) Source rank w/in communicator. 
.br
\fItag\fP (IN) User defined tag. 
.br
\fIcomm\fP (IN) Communicator. 
.br
\fIstatus\fP (OUT) Completion statuses. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or failure status. 
.RE
.PP

.SS "typedef int(* \fBmca_pml_base_module_progress_fn_t\fP)(void)"
.PP
For non-threaded case, provides MCA the opportunity to progress outstanding requests on all ptls. 
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or failure status. 
.RE
.PP

.SS "typedef int(* \fBmca_pml_base_module_recv_fn_t\fP)(void *buf, size_t count, struct ompi_datatype_t *datatype, int src, int tag, struct ompi_communicator_t *comm, ompi_status_public_t *status)"
.PP
Post a receive and wait for completion. 
.PP
\fBParameters:\fP
.RS 4
\fIbuf\fP (IN) User buffer 
.br
\fIcount\fP (IN) Number of elements of the specified datatype 
.br
\fIdatatype\fP (IN) User defined datatype 
.br
\fIsrc\fP (IN) Source rank w/in communicator 
.br
\fItag\fP (IN) User defined tag 
.br
\fIcomm\fP (IN) Communicator 
.br
\fIstatus\fP (OUT) Completion status 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or failure status. 
.RE
.PP

.SS "typedef int(* \fBmca_pml_base_module_send_fn_t\fP)(void *buf, size_t count, struct ompi_datatype_t *datatype, int dst, int tag, mca_pml_base_send_mode_t mode, struct ompi_communicator_t *comm)"
.PP
Post a send request and wait for completion. 
.PP
\fBParameters:\fP
.RS 4
\fIbuf\fP (IN) User buffer. 
.br
\fIcount\fP (IN) Number of elements of the specified datatype. 
.br
\fIdatatype\fP (IN) User defined datatype. 
.br
\fIdst\fP (IN) Peer rank w/in communicator. 
.br
\fItag\fP (IN) User defined tag. 
.br
\fImode\fP (IN) Send mode (STANDARD,BUFFERED,SYNCHRONOUS,READY) 
.br
\fIcomm\fP (IN) Communicator. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or failure status. 
.RE
.PP

.SS "typedef int(* \fBmca_pml_base_module_start_fn_t\fP)(size_t count, struct \fBompi_request_t\fP **requests)"
.PP
Initiate one or more persistent requests. 
.PP
\fBParameters:\fP
.RS 4
\fIcount\fP Number of requests 
.br
\fIrequest\fP Array of persistent requests 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or failure status. 
.RE
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
